/*
Copyright 2023 The Kubernetes Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	"context"

	metav1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
	v1 "k8s.io/cloud-provider-gcp/crd/apis/network/v1"
)

// FakeGKENetworkParamSets implements GKENetworkParamSetInterface
type FakeGKENetworkParamSets struct {
	Fake *FakeNetworkingV1
}

var gkenetworkparamsetsResource = v1.SchemeGroupVersion.WithResource("gkenetworkparamsets")

var gkenetworkparamsetsKind = v1.SchemeGroupVersion.WithKind("GKENetworkParamSet")

// Get takes name of the gKENetworkParamSet, and returns the corresponding gKENetworkParamSet object, and an error if there is any.
func (c *FakeGKENetworkParamSets) Get(ctx context.Context, name string, options metav1.GetOptions) (result *v1.GKENetworkParamSet, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootGetAction(gkenetworkparamsetsResource, name), &v1.GKENetworkParamSet{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1.GKENetworkParamSet), err
}

// List takes label and field selectors, and returns the list of GKENetworkParamSets that match those selectors.
func (c *FakeGKENetworkParamSets) List(ctx context.Context, opts metav1.ListOptions) (result *v1.GKENetworkParamSetList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootListAction(gkenetworkparamsetsResource, gkenetworkparamsetsKind, opts), &v1.GKENetworkParamSetList{})
	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v1.GKENetworkParamSetList{ListMeta: obj.(*v1.GKENetworkParamSetList).ListMeta}
	for _, item := range obj.(*v1.GKENetworkParamSetList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested gKENetworkParamSets.
func (c *FakeGKENetworkParamSets) Watch(ctx context.Context, opts metav1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewRootWatchAction(gkenetworkparamsetsResource, opts))
}

// Create takes the representation of a gKENetworkParamSet and creates it.  Returns the server's representation of the gKENetworkParamSet, and an error, if there is any.
func (c *FakeGKENetworkParamSets) Create(ctx context.Context, gKENetworkParamSet *v1.GKENetworkParamSet, opts metav1.CreateOptions) (result *v1.GKENetworkParamSet, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootCreateAction(gkenetworkparamsetsResource, gKENetworkParamSet), &v1.GKENetworkParamSet{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1.GKENetworkParamSet), err
}

// Update takes the representation of a gKENetworkParamSet and updates it. Returns the server's representation of the gKENetworkParamSet, and an error, if there is any.
func (c *FakeGKENetworkParamSets) Update(ctx context.Context, gKENetworkParamSet *v1.GKENetworkParamSet, opts metav1.UpdateOptions) (result *v1.GKENetworkParamSet, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootUpdateAction(gkenetworkparamsetsResource, gKENetworkParamSet), &v1.GKENetworkParamSet{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1.GKENetworkParamSet), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakeGKENetworkParamSets) UpdateStatus(ctx context.Context, gKENetworkParamSet *v1.GKENetworkParamSet, opts metav1.UpdateOptions) (*v1.GKENetworkParamSet, error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootUpdateSubresourceAction(gkenetworkparamsetsResource, "status", gKENetworkParamSet), &v1.GKENetworkParamSet{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1.GKENetworkParamSet), err
}

// Delete takes name of the gKENetworkParamSet and deletes it. Returns an error if one occurs.
func (c *FakeGKENetworkParamSets) Delete(ctx context.Context, name string, opts metav1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewRootDeleteActionWithOptions(gkenetworkparamsetsResource, name, opts), &v1.GKENetworkParamSet{})
	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeGKENetworkParamSets) DeleteCollection(ctx context.Context, opts metav1.DeleteOptions, listOpts metav1.ListOptions) error {
	action := testing.NewRootDeleteCollectionAction(gkenetworkparamsetsResource, listOpts)

	_, err := c.Fake.Invokes(action, &v1.GKENetworkParamSetList{})
	return err
}

// Patch applies the patch and returns the patched gKENetworkParamSet.
func (c *FakeGKENetworkParamSets) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts metav1.PatchOptions, subresources ...string) (result *v1.GKENetworkParamSet, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootPatchSubresourceAction(gkenetworkparamsetsResource, name, pt, data, subresources...), &v1.GKENetworkParamSet{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1.GKENetworkParamSet), err
}
