/*
Copyright 2023 The Kubernetes Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by informer-gen. DO NOT EDIT.

package v1

import (
	"context"
	time "time"

	metav1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	runtime "k8s.io/apimachinery/pkg/runtime"
	watch "k8s.io/apimachinery/pkg/watch"
	cache "k8s.io/client-go/tools/cache"
	networkv1 "k8s.io/cloud-provider-gcp/crd/apis/network/v1"
	versioned "k8s.io/cloud-provider-gcp/crd/client/network/clientset/versioned"
	internalinterfaces "k8s.io/cloud-provider-gcp/crd/client/network/informers/externalversions/internalinterfaces"
	v1 "k8s.io/cloud-provider-gcp/crd/client/network/listers/network/v1"
)

// GKENetworkParamSetInformer provides access to a shared informer and lister for
// GKENetworkParamSets.
type GKENetworkParamSetInformer interface {
	Informer() cache.SharedIndexInformer
	Lister() v1.GKENetworkParamSetLister
}

type gKENetworkParamSetInformer struct {
	factory          internalinterfaces.SharedInformerFactory
	tweakListOptions internalinterfaces.TweakListOptionsFunc
}

// NewGKENetworkParamSetInformer constructs a new informer for GKENetworkParamSet type.
// Always prefer using an informer factory to get a shared informer instead of getting an independent
// one. This reduces memory footprint and number of connections to the server.
func NewGKENetworkParamSetInformer(client versioned.Interface, resyncPeriod time.Duration, indexers cache.Indexers) cache.SharedIndexInformer {
	return NewFilteredGKENetworkParamSetInformer(client, resyncPeriod, indexers, nil)
}

// NewFilteredGKENetworkParamSetInformer constructs a new informer for GKENetworkParamSet type.
// Always prefer using an informer factory to get a shared informer instead of getting an independent
// one. This reduces memory footprint and number of connections to the server.
func NewFilteredGKENetworkParamSetInformer(client versioned.Interface, resyncPeriod time.Duration, indexers cache.Indexers, tweakListOptions internalinterfaces.TweakListOptionsFunc) cache.SharedIndexInformer {
	return cache.NewSharedIndexInformer(
		&cache.ListWatch{
			ListFunc: func(options metav1.ListOptions) (runtime.Object, error) {
				if tweakListOptions != nil {
					tweakListOptions(&options)
				}
				return client.NetworkingV1().GKENetworkParamSets().List(context.TODO(), options)
			},
			WatchFunc: func(options metav1.ListOptions) (watch.Interface, error) {
				if tweakListOptions != nil {
					tweakListOptions(&options)
				}
				return client.NetworkingV1().GKENetworkParamSets().Watch(context.TODO(), options)
			},
		},
		&networkv1.GKENetworkParamSet{},
		resyncPeriod,
		indexers,
	)
}

func (f *gKENetworkParamSetInformer) defaultInformer(client versioned.Interface, resyncPeriod time.Duration) cache.SharedIndexInformer {
	return NewFilteredGKENetworkParamSetInformer(client, resyncPeriod, cache.Indexers{cache.NamespaceIndex: cache.MetaNamespaceIndexFunc}, f.tweakListOptions)
}

func (f *gKENetworkParamSetInformer) Informer() cache.SharedIndexInformer {
	return f.factory.InformerFor(&networkv1.GKENetworkParamSet{}, f.defaultInformer)
}

func (f *gKENetworkParamSetInformer) Lister() v1.GKENetworkParamSetLister {
	return v1.NewGKENetworkParamSetLister(f.Informer().GetIndexer())
}
